package cn.iocoder.yudao.module.erp.service.autocode;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.mock.mockito.MockBean;


import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.erp.controller.admin.autocode.vo.*;
import cn.iocoder.yudao.module.erp.dal.dataobject.autocode.AutocodeRecordDO;
import cn.iocoder.yudao.module.erp.dal.mysql.autocode.AutocodeRecordMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import org.springframework.context.annotation.Import;

import javax.annotation.Resource;
import java.util.*;
import java.time.LocalDateTime;

import static cn.hutool.core.util.RandomUtil.*;
import static cn.iocoder.yudao.module.erp.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link AutocodeRecordServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(AutocodeRecordServiceImpl.class)
public class AutocodeRecordServiceImplTest extends BaseDbUnitTest {

    @Resource
    private AutocodeRecordServiceImpl autocodeRecordService;

    @Resource
    private AutocodeRecordMapper autocodeRecordMapper;

    @Test
    public void testCreateAutocodeRecord_success() {
        // 准备参数
        AutocodeRecordSaveReqVO createReqVO = randomPojo(AutocodeRecordSaveReqVO.class).setId(null);

        // 调用
        Long autocodeRecordId = autocodeRecordService.createAutocodeRecord(createReqVO);
        // 断言
        assertNotNull(autocodeRecordId);
        // 校验记录的属性是否正确
        AutocodeRecordDO autocodeRecord = autocodeRecordMapper.selectById(autocodeRecordId);
        assertPojoEquals(createReqVO, autocodeRecord, "id");
    }

    @Test
    public void testUpdateAutocodeRecord_success() {
        // mock 数据
        AutocodeRecordDO dbAutocodeRecord = randomPojo(AutocodeRecordDO.class);
        autocodeRecordMapper.insert(dbAutocodeRecord);// @Sql: 先插入出一条存在的数据
        // 准备参数
        AutocodeRecordSaveReqVO updateReqVO = randomPojo(AutocodeRecordSaveReqVO.class, o -> {
            o.setId(dbAutocodeRecord.getId()); // 设置更新的 ID
        });

        // 调用
        autocodeRecordService.updateAutocodeRecord(updateReqVO);
        // 校验是否更新正确
        AutocodeRecordDO autocodeRecord = autocodeRecordMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, autocodeRecord);
    }

    @Test
    public void testUpdateAutocodeRecord_notExists() {
        // 准备参数
        AutocodeRecordSaveReqVO updateReqVO = randomPojo(AutocodeRecordSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> autocodeRecordService.updateAutocodeRecord(updateReqVO), AUTOCODE_RECORD_NOT_EXISTS);
    }

    @Test
    public void testDeleteAutocodeRecord_success() {
        // mock 数据
        AutocodeRecordDO dbAutocodeRecord = randomPojo(AutocodeRecordDO.class);
        autocodeRecordMapper.insert(dbAutocodeRecord);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbAutocodeRecord.getId();

        // 调用
        autocodeRecordService.deleteAutocodeRecord(id);
       // 校验数据不存在了
       assertNull(autocodeRecordMapper.selectById(id));
    }

    @Test
    public void testDeleteAutocodeRecord_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> autocodeRecordService.deleteAutocodeRecord(id), AUTOCODE_RECORD_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetAutocodeRecordPage() {
       // mock 数据
       AutocodeRecordDO dbAutocodeRecord = randomPojo(AutocodeRecordDO.class, o -> { // 等会查询到
           o.setRuleId(null);
           o.setGenDate(null);
           o.setGenIndex(null);
           o.setLastResult(null);
           o.setLastSerialNo(null);
           o.setLastInputChar(null);
           o.setRemark(null);
           o.setCreateTime(null);
       });
       autocodeRecordMapper.insert(dbAutocodeRecord);
       // 测试 ruleId 不匹配
       autocodeRecordMapper.insert(cloneIgnoreId(dbAutocodeRecord, o -> o.setRuleId(null)));
       // 测试 genDate 不匹配
       autocodeRecordMapper.insert(cloneIgnoreId(dbAutocodeRecord, o -> o.setGenDate(null)));
       // 测试 genIndex 不匹配
       autocodeRecordMapper.insert(cloneIgnoreId(dbAutocodeRecord, o -> o.setGenIndex(null)));
       // 测试 lastResult 不匹配
       autocodeRecordMapper.insert(cloneIgnoreId(dbAutocodeRecord, o -> o.setLastResult(null)));
       // 测试 lastSerialNo 不匹配
       autocodeRecordMapper.insert(cloneIgnoreId(dbAutocodeRecord, o -> o.setLastSerialNo(null)));
       // 测试 lastInputChar 不匹配
       autocodeRecordMapper.insert(cloneIgnoreId(dbAutocodeRecord, o -> o.setLastInputChar(null)));
       // 测试 remark 不匹配
       autocodeRecordMapper.insert(cloneIgnoreId(dbAutocodeRecord, o -> o.setRemark(null)));
       // 测试 createTime 不匹配
       autocodeRecordMapper.insert(cloneIgnoreId(dbAutocodeRecord, o -> o.setCreateTime(null)));
       // 准备参数
       AutocodeRecordPageReqVO reqVO = new AutocodeRecordPageReqVO();
       reqVO.setRuleId(null);
       reqVO.setGenDate(null);
       reqVO.setGenIndex(null);
       reqVO.setLastResult(null);
       reqVO.setLastSerialNo(null);
       reqVO.setLastInputChar(null);
       reqVO.setRemark(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<AutocodeRecordDO> pageResult = autocodeRecordService.getAutocodeRecordPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbAutocodeRecord, pageResult.getList().get(0));
    }

}